function error = trainAndCheck(whichData, trainOrCheck)

if nargin < 1
    whichData = 'train';%1;%[1 3];  %training Data by default
end
if nargin < 2
    displayFlag = false;
end

A = [ ];
b = [ ];
%-------------
for n=[1 2 3] %whichData
    load(['GraphicsSVMFullTrainingData' num2str(n) '.mat']);
    clear distanceVector;
    
    goodTrainingSet = timeStampMatchingError < 0.2;
    clear timeStampMatchingError;
    
    featureV = featureVector(:,:, find(goodTrainingSet) );
    clear featureVector;
    
    labeledD = labeledDistance(:, find(goodTrainingSet) );
    clear labeledDistance;
    
    if strcmp(whichData, 'train')
        chooseImages = find( mod(1:size(labeledD,2),3) ~= 0);
    elseif strcmp(whichData, 'test')
        chooseImages = find( mod(1:size(labeledD,2),3) == 0);
    end
    labeledD = labeledD(:, chooseImages);
    featureV = featureV(:,:, chooseImages);    
    
    b1 = log( reshape(labeledD, 1, size(labeledD,1)*size(labeledD,2)) )';
        
    A1 = reshape( featureV, size(featureV,1), size(labeledD,1)*size(labeledD,2))';
    clear featureV;
    clear labeledD;
    A1 = [repmat(1,size(A1,1),1) A1];
    
    A = [A; A1];
    b = [b; b1];
end
clear b1 A1;

size(A)

load weights_GraphicsSVM.mat
size(w)
error = A*w-b;

sortedAbsError = -sort( -abs(error) );
sortedAbsErrorMeanRemoved = -sort( -abs(error - mean(error)));
clear b;
clear A;

lenE = length( sortedAbsError);

if displayFlag
    ['Average Error = ' num2str(mean(sortedAbsError) )]%round(lenE/20):lenE))
    ['Mean Removed Error = ' num2str(mean(sortedAbsErrorMeanRemoved)) ]
    figure, plot(sortedAbsError);
end

return;