%function combineGraphicsLaser

overlappingFlag = true;

global vectorBadDecisionLaser vectorChoosenBestColumnLaser
global vectorBadDecisionGraphics vectorChoosenBestColumnGraphics meanFractionHazardousColumns
global hazardDistance
configurationFile;

if ~length(vectorBadDecisionLaser)
    [vectorBadDecisionLaser vectorChoosenBestColumnLaser, meanFractionHazardousColumns] = ...
        trainingCurve({'laws' 'harris'}, 'linear', 'laser', 0, overlappingFlag);
    [vectorBadDecisionGraphics vectorChoosenBestColumnGraphics, meanFractionHazardousColumns] = ...
        trainingCurve({'laws'}, 'linear', 'graphics', 5, overlappingFlag); 
end

nSamples = length(vectorBadDecisionLaser);

bothBad = sum( vectorBadDecisionLaser & vectorBadDecisionGraphics ) / nSamples;
eitherBad = sum( vectorBadDecisionLaser | vectorBadDecisionGraphics )/ nSamples;
laserBad= sum( vectorBadDecisionLaser) / nSamples;
graphicsBad = sum( vectorBadDecisionGraphics) / nSamples;

disp(['Laser policy crash rate                        ' num2str(laserBad*100) '% times.']);
disp(['Graphics policy crash rate                     ' num2str(graphicsBad*100) '% times.']);
disp(['Laser/Graphics combination worst performance = ' num2str(eitherBad*100) '% times.']);
disp(['Laser/Graphics combination best performance =  ' num2str(bothBad*100) '% times.']);
disp(['The random case policy crash rate              ' num2str(meanFractionHazardousColumns*100) '% times.']);
disp(['The worst case policy crash rate               65% times.']);
disp('We get........');

timesAgree = [];

%(nTopLaser, nTopGraphics) = (2,3):.0370 and (2,2): .0376  -  are kind of optimal
% (3,2) and (3,3) are at .039306
for nTopLaser = 1:4
for nTopGraphics = 1:4
for n=1:nTopLaser
    timesAgree(n,:) = sum( repmat(vectorChoosenBestColumnLaser(n,:), nTopGraphics,1) == vectorChoosenBestColumnGraphics(1:nTopGraphics,:), 1); 
end

columnTaken = zeros( 1,size(timesAgree,2));
for n = 1:nTopLaser
    columnTaken = columnTaken + n * (timesAgree(n,:) >= 1) .* (columnTaken == 0);
end

columnTaken = columnTaken + 1 .* (columnTaken == 0);

for k = 1:size(vectorChoosenBestColumnLaser,2)
    choosenConcurDistance(1,k) = vectorChoosenBestColumnLaser( 4+columnTaken(k), k);
end

timesConcurBad = choosenConcurDistance < log(hazardDistance);
timesConcurBadMean = sum(timesConcurBad)/nSamples;

disp(['nTopLaser = ' num2str(nTopLaser) ',   nTopGraphics = ' num2str(nTopGraphics) '   , timesConcurGood = '...
        num2str(100*timesConcurBadMean) '% times' ]);
end
end
%timeGraphicsCorrect = sum(vectorChoosenBestColumnLaser(1,:) == vectorChoosenBestColumnLaser(3,:) ) / nSamples
%timeGraphicsCorrect = sum(vectorChoosenBestColu    mnLaser(1,:) == vectorChoosenBestColumnLaser(3,:) ) / nSamples

return;
