function configurationFile(whichData)

if nargin < 1
    whichData = 'laser';
end

global bandWidth bandHeight thetaStep nTopRadon
global nearestDistance largestDistance hazardDistance
global timeStampErrorThreshold directoryPath
global maxGraphicsDistance graphicsScaleFactor
global nGridCol

bandWidth = 11;
bandHeight = 0;
thetaStep = 15;
nTopRadon = 2;

maxGraphicsDistance = 250;
minGraphicsDistance = .2;
switch lower(whichData)
    case 'laser'
        nearestDistance = log(.23);   %in meters
        largestDistance = log(81.91);   %in meters
    case 'graphics'
        nearestDistance = log(minGraphicsDistance);
        largestDistance = log(maxGraphicsDistance);
        graphicsScaleFactor = 1;
end

hazardDistance = 5;
timeStampErrorThreshold = .1;
directoryPath = '~/scratch/savedMatFiles/';

nGridCol = 16;