function featureTest(readAgain, frameNum)
%this function tests and displays filtered images for eyeballing features
%to be used for vision
global mov;

if nargin >=1 && readAgain
    mov = aviread('manualOne.avi');
end
if nargin < 2
    frameNum = 1;
end

for frame = frameNum:frameNum
   img = mov(1,frame).cdata;
   ycbcr_img = rgb2ycbcr(img);
   figure, 
   subplot(2,2,1), imshow(img);
   subplot(2,2,2), imagesc(ycbcr_img(:,:,1));
   subplot(2,2,3), imagesc(ycbcr_img(:,:,2));
   subplot(2,2,4), imagesc(ycbcr_img(:,:,3));
   
   edgeImageY = edge( ycbcr_img(:,:,1), 'sobel');
   edgeImageCb = edge( ycbcr_img(:,:,2), 'sobel');
   edgeImageCr = edge( ycbcr_img(:,:,3), 'sobel');
   
   figure,
   subplot(2,2,1), imshow(img);
   subplot(2,2,2), imagesc(edgeImageY);
   subplot(2,2,3), imagesc(edgeImageCb);
   subplot(2,2,4), imagesc(edgeImageCr);
   
   close_img = ycbcr_img(37:85, 38:46, 1);
   far_img = ycbcr_img(44:92, 123:131,  1);
   %figure, image( abs(fft2( double(close_img) ) ) );
   %figure, image( abs(fft2( double(far_img) ) ) );
   
   stdVec = zeros(size(img,1), 1);
   for row = 1:size(img,1)-10
       imgSelected = double(ycbcr_img(row:row+10, 1:size(ycbcr_img,2), 1) );
       imgSelectedCb = double(ycbcr_img(row:row+10, 1:size(ycbcr_img,2), 2) );
       imgSelectedCr = double(ycbcr_img(row:row+10, 1:size(ycbcr_img,2), 3) );
       stdVec(row,1) = std(imgSelected(:) );
       stdVec(row,2) = std(imgSelectedCb(:) );
       stdVec(row,3) = std(imgSelectedCr(:) );
       
       %hist( double(close_img(:)), 20 );
       %figure, hist( double(far_img(:)), 20 );
   end
   
   figure, plot(stdVec);
   
end

return;