function featureTest(readAgain, frameNum, displayFlag)
%this function tests and displays filtered images for eyeballing features
%to be used for vision
global mov;

if nargin >=1 && readAgain
    mov = aviread('manualOne.avi');
end
if nargin < 2
    frameNum = 1;
end
if nargin < 3
    displayFlag = false;
end

img = zeros( size(mov(1,1).cdata ) );

L3 = [1 2 1];
E3 = [-1 0 1];
S3 = [-1 2 1];

for frame = frameNum:frameNum
   img = mov(1,frame).cdata;
   ycbcr_img = rgb2ycbcr(img);
   imgY = single(ycbcr_img(:,:,1) );
         
   L3img = conv2(imgY, L3, 'same');
   E3img = conv2(imgY, E3, 'same');
   S3img = conv2(imgY, S3, 'same');
   
   H(:,:,1) = conv2(L3img, L3', 'same');
   H(:,:,2) = conv2(E3img, L3', 'same');
   H(:,:,3) = conv2(S3img, L3', 'same');
   
   H(:,:,4) = conv2(L3img, E3', 'same');
   H(:,:,5) = conv2(E3img, E3', 'same');
   H(:,:,6) = conv2(S3img, E3', 'same');
   
   H(:,:,7) = conv2(L3img, S3', 'same');
   H(:,:,8) = conv2(E3img, S3', 'same');
   H(:,:,9) = conv2(S3img, S3', 'same');
   
   H(:,:,10) = conv2( conv2( single(ycbcr_img(:,:,2)), L3, 'same'), L3', 'same');
   H(:,:,11) = conv2( conv2( single(ycbcr_img(:,:,3)), L3, 'same'), L3', 'same');
    
   
   featureVector1 = mean( H, 1);
   columnWidth = round(size(img,2)/16);
   featureVector(frame,:,:) = filter( ones(1,columnWidth), columnWidth, featureVector1, [], 2);

   if displayFlag
       figure, 
       subplot(2,2,1), imshow(img);
       subplot(2,2,2), imagesc(ycbcr_img(:,:,1));
       subplot(2,2,4), imagesc(ycbcr_img(:,:,2));
       subplot(2,2,3); plot( squeeze(featureVector(frame,:,:)) );
       axis tight; 
   end
end
   
save featureVector.mat featureVector

return;