function [featureVector] = makeFeatureGroundSeg(type, timeStampImage, dataset)

persistent groundSeg3 groundSeg1
global nGridCol

switch type
    case {'groundseg3', 'groundseg'}
        switch dataset
            case {'laser1', 'laser2', 'laser'}
                if ~length(groundSeg3)
                    load groundSeg3.mat;
                end
            case {'graphics' 'graphics1', 'graphics2', 'graphics3', 'graphics4', 'graphics5'}
                load(['groundSeg3_' dataset]);
        end
        [m closestIndex] = min( abs( groundSeg3(:,1) - timeStampImage));
        featureVectorLinear = reshape(groundSeg3(closestIndex, 2:size(groundSeg3,2)), 3, nGridCol);
        %featureVectorLog = log(1+reshape(groundSeg3(closestIndex, 2:49), 3, nGridCol) );
        featureVectorQuad = (1+reshape(groundSeg3(closestIndex, 2:size(groundSeg3,2)), 3, nGridCol) ).^2;
        featureVector = [featureVectorLinear; featureVectorQuad];
    case 'groundseg1'
        featureVector = zeros(0, nGridCol);
end

return;