function [featureVector] = makeFeatureTextureOverlapping(img)
%this function returnd and displays feature vector from the image 
%startMakingNewFeatureTexture should be executed once before calling this
%function

global columnWidth nGridCol nFeatures gridNum L3 E3 S3 M N rowWidth

if nargin < 1
    mov = aviread('manualOne.avi');
    img = mov(1,frame).cdata;
end

ycbcr_img = rgb2ycbcr(img); %This computer has no image processing functions!!

imgY = ycbcr_img(:,:,1);
imgEdge = edge(imgY, 'sobel');

L3img = conv2(imgY, L3, 'same');
E3img = conv2(imgY, E3, 'same');
S3img = conv2(imgY, S3, 'same');
   
H(:,:,1) = conv2(L3img, L3', 'same');
H(:,:,2) = conv2(E3img, L3', 'same');
H(:,:,3) = conv2(S3img, L3', 'same');
   
H(:,:,4) = conv2(L3img, E3', 'same');
H(:,:,5) = conv2(E3img, E3', 'same');
H(:,:,6) = conv2(S3img, E3', 'same');
   
H(:,:,7) = conv2(L3img, S3', 'same');
H(:,:,8) = conv2(E3img, S3', 'same');
H(:,:,9) = conv2(S3img, S3', 'same');
   
H(:,:,10) = conv2( conv2( (ycbcr_img(:,:,2)), L3, 'same'), L3', 'same');
H(:,:,11) = conv2( conv2( (ycbcr_img(:,:,3)), L3, 'same'), L3', 'same');
  
for g = 2:gridNum
    for c = 1:nGridCol
        featureVector2(g,c,1:11) = mean( mean( H(g*rowWidth-(2*rowWidth-1):g*rowWidth, ...
            c*columnWidth-(columnWidth-1):c*columnWidth,:), 2), 1);
        %temp = radon( imgEdge(g*rowWidth-(rowWidth-1):g*rowWidth, ...
        %    c*columnWidth-(columnWidth-1):c*columnWidth), 0:15:179 );
        %tempRadonFeature = max(temp,[],1);
        %if max(tempRadonFeature) > 0
        %    radonFeature = tempRadonFeature / max(tempRadonFeature);
        %else
        %    radonFeature = zeros( size(tempRadonFeature));
        %end
        %featureVector2(g,c,12:23) = permute(radonFeature, [1 3 2] );
    end
end
   
featureVector = reshape( permute( featureVector2, [1 3 2]), [gridNum*nFeatures nGridCol] );

%    if displayFlag
%        figure, 
%        subplot(2,2,1), imshow(img);
%        subplot(2,2,2), imagesc(ycbcr_img(:,:,1));
%        subplot(2,2,4), imagesc(ycbcr_img(:,:,2));
%        subplot(2,2,3); plot( squeeze(featureVector(frame,:,:)) );
%        axis tight; 
%    end
   
return;