function [featureVector, timeStampMatchingError] = makeFeatureEverythingCar(type, timeStampImage, dataset)

global nGridCol
global directoryPath

persistent everythingLog timeStamp laser1Log laser2Log graphicsLog firstTime

if ~length(firstTime)
    firstTime = 1;
end

switch type
    case {'everythingcar'}
        switch dataset
            case {'laser', 'laser1'}
                if ~length(laser1Log)
                    disp('Loading Laser1 Feature Vector.....');
                    load([directoryPath 'FeatureVector/everythingcar.mat']);
                    laser1Log = 1;
                    laser2Log = [];  graphicsLog = [];
                end
                [timeStampMatchingError closestIndex] = min( abs(timeStamp - timeStampImage));
            case 'laser2'
                if ~length(laser2Log)
                    disp('Loading Feature Vector: Everything....may take a while, so take a nap ;-)');
                    fid = fopen('/tmp/Ashutosh/groundSeg3_lowes_harris_append_log.txt');
                    tline = fgets(fid);
                    tline = fgets(fid);
                    everythingLog = sscanf(tline, '%lf', inf);
                    nOneLine = length(everythingLog);
                    %while ~feof(fid)
                        everythingLog = [everythingLog fscanf(fid, '%lf', [nOneLine 130199]) ];
                        %everythingLog = [everythingLog fscanf(fid, '%lf', [nOneLine 130199]) ];
                        size(everythingLog)
                        %end
                    everythingLog = reshape(everythingLog, nOneLine, 14, size(everythingLog, 2)/14);
                    timeStamp = permute(everythingLog(1,1,:), [3 1 2]);
                    timeStamp = rem(timeStamp, 1000000);
                    laser2Log = 1;
                    laser1Log = []; graphicsLog = [];
                end
                [timeStampMatchingError closestIndex] = min( abs(timeStamp - timeStampImage));
            case {'graphics', 'graphics5'}
                if ~length(graphicsLog)
                    disp('Loading Feature Vector: Everything....');
                    ['/tmp/Ashutosh/groundSeg3_lowes_' dataset '.txt']
                    fid = fopen(['/tmp/Ashutosh/groundSeg3_lowes_' dataset '.txt']);
                    tline = fgets(fid);
                    tline = fgets(fid);
                    everythingLog = sscanf(tline, '%lf', inf);
                    nOneLine = length(everythingLog);
                    %while ~feof(fid)
                        everythingLog = [everythingLog fscanf(fid, '%lf', [nOneLine inf]) ];
                        %everythingLog = [everythingLog fscanf(fid, '%lf', [nOneLine 130199]) ];
                        size(everythingLog)
                        %end
                    everythingLog = reshape(everythingLog, nOneLine, 14, size(everythingLog, 2)/14);
                    timeStamp = permute(everythingLog(1,1,:), [3 1 2]);
                    timeStamp = 0:999;%rem(timeStamp, 1000000);
                    graphicsLog = 1;
                    laser1Log = []; laser2Log = [];
                end
                [timeStampMatchingError closestIndex] = min( abs(timeStamp - timeStampImage));
        end
        

        
        if timeStampMatchingError > 1
            timeStampMatchingError
        end
        
        featureVector = everythingLog(3:size(everythingLog,1),:,closestIndex);
end

return;