function [featureVector] = makeFeatureVectorHarris(type, timeStampImage, dataset)

global nGridCol
global directoryPath

persistent oldposition harrisLog timeStampHarris

switch type
    case {'harris'}
        switch dataset
            case {'laser', 'laser1', 'laser2'}
                if ~length(harrisLog)
                    load([directoryPath 'FeatureVector/harris.mat']);
                end
            case {'graphics', 'graphics5'}
                load([directoryPath 'FeatureVector/harris_' dataset '.mat']);
        end

        [m closestIndex] = min( abs( timeStampHarris - timeStampImage));
        
        featureVector = harrisLog(3:size(harrisLog,1),:,closestIndex);
end

return;