function makeOutputMovie(readAgain, imageIndex, makeMovieFlag, filename)
global A;

global columnWidth nGridCol nFeatures gridNum

if nargin < 4
    filename = 'fullFeaturesTrainingData2.mat';
end
if nargin < 3
    makeMovieFlag = false;
end
if nargin < 2
    imageIndex = [145 145];
end
if nargin < 1
    readAgain = false;
end

imageStart = imageIndex(1);
imageEnd = imageIndex(2);

if readAgain || max(size(A)) <= 0
    fid = fopen('LaserData/writelog_2005_01_27_11_15.log');
    tline = fgets(fid);
    tline = fgets(fid);
    
    A = zeros(8364, 727);
    %reading laser data
    scanNumber = 0;
    %for scanNumber = 1:8364
    while ~feof(fid)
        tline = fgets(fid);   %sync line
        whichLine = sscanf( tline(26:31),  '%s', 1);
        if strcmp(whichLine, 'laser')
            scanNumber = scanNumber + 1;
            A(scanNumber, :) = sscanf( tline(35:length(tline)), ' %lf', inf)';
            A(scanNumber, 1) = A(scanNumber, 1) - 1106000000;
        end
    end
end

timeStampLaser = A(:,1);
laserScanMatrix = A(:,6:2:size(A,2));
size(timeStampLaser);

%plot( laserScanMatrix(2000,:), '.-' );

filesList = dir('ImageData');

if makeMovieFlag
    mov = avifile('gates_2_linear.avi');
    mov.fps = 2;
    frameNumber = 0;
end

close all; 
if makeMovieFlag
  fig = figure;
  set(fig,'DoubleBuffer','on');
  set(gca,'xlim',[1 176],'ylim',[1 144],...
     	   'NextPlot','replace','Visible','off')
end

%---------predicting distance---------------
    load(filename);
    clear distanceVector;
   % b = log( reshape(labeledDistance, 1,
   % size(labeledDistance,1)*size(labeledDistance,2) ) )';
   % b = log( reshape(labeledDistance, 1, size(labeledDistance,1)*size(labeledDistance,2) ) )';
    b = ( reshape(labeledDistance, 1, size(labeledDistance,1)*size(labeledDistance,2) ) )';
    T = reshape( featureVector, size(featureVector,1), size(featureVector,2)*size(featureVector,3) )';
    %T = [repmat(1,size(T,1),1) T];
    load weights13_nobias_linear.mat;

    predictedDistance = reshape(T*w, size(featureVector,2), size(featureVector,3) );
    actualMinDistance = labeledDistance;
    
    size(predictedDistance)
    clear b T;


filename = filesList(3).name;
img = imread(['ImageData/' filename]);
startMakingNewFeatureTexture(img);
nCol = size(img,2);

maxFrames = 400;
featureVector = zeros(gridNum*nFeatures, nGridCol, maxFrames);
timeStampMatchingError = 50*ones(1, maxFrames);
labeledDistance = -1*ones(nGridCol, maxFrames);
laserDistanceVector = 0*ones(nCol, maxFrames);

    
    
%for nLaser = 1000:1500%1:8364  
for nFile = imageStart:imageEnd%size(filesList, 1)
    arrayIndex = nFile - imageStart + 1;
    filename = filesList(nFile).name;
    timeStampImage = str2num( filename(9:14) ) + str2num( filename(16:17) ) / 1000;
    
    [m closestIndex] = min( abs(timeStampLaser - 1.3 - timeStampImage ));
    nLaser = closestIndex;
    
    img = imread(['ImageData/' filename]);

    %------adjusting laser scan and images--------------
    indexPlot = 150:225;
    laserCenter = 182;
    laserLength = length(indexPlot);
    
    %for c = 1:nCol
    c = 1:nCol;
    %laserDistanceVector(:, arrayIndex) = 144 - 15*log(laserScanMatrix( nLaser, round(laserCenter - (c-nCol/2)*laserLength/nCol) ) )';
    %laserDistanceVector(:, arrayIndex) = 144 - 15*log(actualMinDistance( min(16,round((16+1)/2 + (c-nCol/2)*16/nCol)), arrayIndex ) )';
    laserDistanceVector(:, arrayIndex) = 144 - 2*(actualMinDistance( min(16,round((16+1)/2 + (c-nCol/2)*16/nCol)), arrayIndex ) )';
    predictedDistanceVector(:, arrayIndex) = 144 - 2*predictedDistance( min(16,round((16+1)/2 + (c-nCol/2)*16/nCol)), arrayIndex )';
    [m maxI] = max(predictedDistance(:,arrayIndex) );
    maxDistancePosition = round(nCol/2 + (maxI - (16+1)/2)*nCol/16 );
    
 
    %end
    %----------------------------

    for n = 1:nGridCol
       labeledDistance(n,arrayIndex) = min( laserDistanceVector(n*columnWidth-(columnWidth-1):n*columnWidth, arrayIndex) );
    end
       
    %------plotting to create movie---------
    if makeMovieFlag
        image(img);   hold on;   axis tight;
        plot( laserDistanceVector(:,arrayIndex), 'ro-'); 
        plot( predictedDistanceVector(:, arrayIndex), 'b.-');  
        fill( maxDistancePosition + [-3 -3 3 3], 90 + [-3 3 3 -3], 'y');
        hold off;
        text(10,10, ['Image: ' num2str(timeStampImage) '    Laser match = ' num2str(timeStampLaser(nLaser)) ...
            '    Image no. = ' num2str(nFile)]);
        frameNumber = frameNumber + 1;
        M = getframe;  %(gca);
        mov = addframe(mov, M);
    end
    %----------end creating movie-----------
    
    
end

if makeMovieFlag
    mov = close(mov);
end