function [A, b] = outsideTraining(fileNumbers, featureType, whichData, chooseFactor)

global timeStampErrorThreshold directoryPath nGridCol
configurationFile;

A = [ ];
b = [ ];

if min(fileNumbers) > 16
    whichData = 3;
end

%-------------
for n=fileNumbers
    load([directoryPath featureType num2str(n) '.mat']);
    clear distanceVector;
    
    goodTrainingSet = timeStampMatchingError < timeStampErrorThreshold;
    %clear timeStampMatchingError;
    
    featureV = featureVector(:,:, find(goodTrainingSet) );
    clear featureVector;
    labeledD = labeledDistance(2:15, find(goodTrainingSet) );
    clear labeledDistance;

    size(featureV);
    size(labeledD);

    if whichData == 1
        chooseImages = find( mod(1:size(labeledD,2),chooseFactor) ~= 0);
    elseif whichData == 2
        chooseImages = find( mod(1:size(labeledD,2),chooseFactor) == 0);
    elseif whichData == 3
        chooseImages = 1:size(labeledD,2);
    end
    labeledD = labeledD(:, chooseImages);
    featureV = featureV(:,:, chooseImages); 
    
    b1 = log( reshape(labeledD, 1, size(labeledD,1)*size(labeledD,2)) )';
    
    A1 = reshape( featureV, size(featureV,1), size(featureV,2)*size(featureV,3))';
    clear featureV;
    clear labeledD;
        
    A = [A; A1];
    b = [b; b1];
end
clear b1 A1;

size(A)
size(b)

if whichData == 1 || whichData == 3
    disp(['Special Training for matrix size ' num2str(size(A,1)) 'x' num2str(size(A,2)) '...']);
    w = pinv(A)*b;
    save([directoryPath 'tmptmptmp.mat'], 'w');
    'Saved to tmptmptmp.mat'
else
    load([directoryPath 'tmptmptmp.mat']);
end

error = A*w - b;
meanError = mean( abs(error))

return;