function predictDistance(imageNumber, makeMovieFlag)

if nargin < 2
    makeMovieFlag = false;
end
if nargin < 1
    imageNumber = 145;
end

load weights.mat;

filesList = dir('../../Laser');

if makeMovieFlag
    mov = avifile('output_t9_long_training_set.avi');
    mov.fps = 2;
    frameNumber = 0;
end

distanceVector = 288*ones(352,1);

for nFile = imageNumber:imageNumber+1100 %size(filesList, 1)
    filename = filesList(nFile).name;
    
    img = imread(['../../Laser/' filename]);
    featureVector = makeFeatureTexture(img);
      
    distance = exp(featureVector' * w);
    [m maxI] = max(distance);
    nCol = size(img,2);
    
    for c = ceil(nCol/16) : floor(nCol-nCol/16)
        distanceVector(c) = 288 - 5*distance( round(14/2 + (c-nCol/2)*14/(nCol+1)) );
    end
    maxDistancePosition = (nCol/2 + (maxI - 14/2)*(nCol-2*nCol/16)/14 );
    
    if makeMovieFlag
        image(img);    hold on;   axis tight;
        plot( distanceVector, 'ro-');    
        
        fill( maxDistancePosition + [-5 -5 5 5], 200 + [-5 5 5 -5], 'y');
        
        hold off;
        frameNumber = frameNumber + 1;
        M = getframe(gca);
        mov = addframe(mov, M);
    end
end

if makeMovieFlag
    mov = close(mov);
end